Subject: Re: [iproute2] tc: Show classes more hierarchically]

From: Vadim Kochan <[email-masked]>
Date: Thu, 18 Dec 2014 15:16:53 +0200

On Thu, Dec 18, 2014 at 10:46:06AM -0200, Marcelo Ricardo Leitner wrote:
> On 18-12-2014 10:23, Vadim Kochan wrote:
> >On Thu, Dec 18, 2014 at 10:26:37AM -0200, Marcelo Ricardo Leitner wrote:
> >>>+---1:1(htb) rate 6Mbit ceil 6Mbit burst 15Kb cburst 1599b
> >>>     |    * Send 100 pkts ...
> >>>     |    * Rate 10mbit ...
> >>>     +---1:10(htb) rate 5Mbit ceil 5Mbit burst 15Kb cburst 1600b
> >>>     |   |    * Send 100 pkts ...
> >>>     |   |    * Rate 10mbit ...
> >>>     |   +---1:11(htb) rate 3Mbit ceil 6Mbit burst 15Kb cburst 1599b
> >>>     |   |   |    * Send 100 pkts ...
> >>>     |   |   |    * Rate 10mbit ...
> >>>     |   |   +---1:111(htb) prio 0 rate 1Kbit ceil 6Mbit burst 15Kb cburst 1599b
> >>>     |   |   |   |    * Send 100 pkts ...
> >>>     |   |   |   |    * Rate 10mbit ...
> >>                    ^ these are confusing IMHO, rest looks good to me
> >>
> >>   Marcelo
> >>
> >
> >
> >Yes, just fixed it to :
> 
> Cool
> 
> >+---1:2(htb) rate 6Mbit ceil 6Mbit burst 15Kb cburst 1599b
> >|   |    * Send 100 pkts ...
> >|   |    * Rate 10mbit ...
> >|   +---1:40(htb) prio 0 rate 5Mbit ceil 5Mbit burst 15Kb cburst 1600b
> >|   |        * Send 100 pkts ...
> >|   |        * Rate 10mbit ...
> >|   +---1:50(htb) prio 0 rate 3Mbit ceil 6Mbit burst 15Kb cburst 1599b
> >|   |        * Send 100 pkts ...
> >|   |        * Rate 10mbit ...
> >|   +---1:60(htb) prio 0 rate 1Kbit ceil 6Mbit burst 15Kb cburst 1599b
> >|            * Send 100 pkts ...
> >|            * Rate 10mbit ...
> >|
> >+---1:1(htb) rate 6Mbit ceil 6Mbit burst 15Kb cburst 1599b
> >     |    * Send 100 pkts ...
> >     |    * Rate 10mbit ...
> >     +---1:10(htb) rate 5Mbit ceil 5Mbit burst 15Kb cburst 1600b
> >     |   |    * Send 100 pkts ...
> >     |   |    * Rate 10mbit ...
> >     |   +---1:11(htb) rate 3Mbit ceil 6Mbit burst 15Kb cburst 1599b
> >     |   |   |    * Send 100 pkts ...
> >     |   |   |    * Rate 10mbit ...
> >     |   |   +---1:111(htb) prio 0 rate 1Kbit ceil 6Mbit burst 15Kb cburst 1599b
> >     |   |   |        * Send 100 pkts ...
> >     |   |   |        * Rate 10mbit ...
> >     |   |   +---1:112(htb) prio 0 rate 1Kbit ceil 6Mbit burst 15Kb cburst 1599b
> >     |   |            * Send 100 pkts ...
> >     |   |            * Rate 10mbit ...
> >     |   |
> >     |   +---1:12(htb) prio 0 rate 1Kbit ceil 6Mbit burst 15Kb cburst 1599b
> >     |            * Send 100 pkts ...
> >     |            * Rate 10mbit ...
> >     |
> >     +---1:20(htb) prio 0 rate 3Mbit ceil 6Mbit burst 15Kb cburst 1599b
> >     |        * Send 100 pkts ...
> >     |        * Rate 10mbit ...
> >     +---1:30(htb) prio 0 rate 1Kbit ceil 6Mbit burst 15Kb cburst 1599b
> >              * Send 100 pkts ...
> >              * Rate 10mbit ...
> >
> >I am not sure about the better format to print stats - use '*' or '>' as
> >prefix, '*' - seems better ?
> 
> TBH I don't think we need one in there. It's already linked to the items due
> to the tree on them. If you just align them to start right where the the
> first word after the ')' begins, it would be good. Like:
> 
>       |   +---1:11(htb) rate 3Mbit ceil 6Mbit burst 15Kb cburst 1599b
>       |   |   |         Send 100 pkts ...
>       |   |   |         Rate 10mbit ...
>       |   |   +---1:111(htb) prio 0 rate 1Kbit ceil 6Mbit burst 15Kb cburst
> 1599b
>       |   |   |              Send 100 pkts ...
>       |   |   |              Rate 10mbit ...
>       |   |   +---1:112(htb) prio 0 rate 1Kbit ceil 6Mbit burst 15Kb cburst
> 1599b
> 
> But I don't know how large this will get..
> 
> Yet I don't mind having one marker in there. Let's see what others think
> about it.
> 
> Regards,
> Marcelo
> 

I corrected regarding to your comments:

+---1:2(htb) rate 6Mbit ceil 6Mbit burst 15Kb cburst 1599b 
|   |        Send 100 pkts ...
|   |        Rate 10mbit ...
|   |
|   +---1:40(htb) prio 0 rate 5Mbit ceil 5Mbit burst 15Kb cburst 1600b 
|   |             Send 100 pkts ...
|   |             Rate 10mbit ...
|   |    
|   +---1:50(htb) prio 0 rate 3Mbit ceil 6Mbit burst 15Kb cburst 1599b 
|   |             Send 100 pkts ...
|   |             Rate 10mbit ...
|   |    
|   +---1:60(htb) prio 0 rate 1Kbit ceil 6Mbit burst 15Kb cburst 1599b 
|                 Send 100 pkts ...
|                 Rate 10mbit ...
|   
+---1:1(htb) rate 6Mbit ceil 6Mbit burst 15Kb cburst 1599b 
    |        Send 100 pkts ...
    |        Rate 10mbit ...
    |
    +---1:10(htb) rate 5Mbit ceil 5Mbit burst 15Kb cburst 1600b 
    |   |         Send 100 pkts ...
    |   |         Rate 10mbit ...
    |   |
    |   +---1:11(htb) rate 3Mbit ceil 6Mbit burst 15Kb cburst 1599b 
    |   |   |         Send 100 pkts ...
    |   |   |         Rate 10mbit ...
    |   |   |
    |   |   +---1:111(htb) prio 0 rate 1Kbit ceil 6Mbit burst 15Kb cburst 1599b 
    |   |   |              Send 100 pkts ...
    |   |   |              Rate 10mbit ...
    |   |   |    
    |   |   +---1:112(htb) prio 0 rate 1Kbit ceil 6Mbit burst 15Kb cburst 1599b 
    |   |                  Send 100 pkts ...
    |   |                  Rate 10mbit ...
    |   |   
    |   +---1:12(htb) prio 0 rate 1Kbit ceil 6Mbit burst 15Kb cburst 1599b 
    |                 Send 100 pkts ...
    |                 Rate 10mbit ...
    |   
    +---1:20(htb) prio 0 rate 3Mbit ceil 6Mbit burst 15Kb cburst 1599b 
    |             Send 100 pkts ...
    |             Rate 10mbit ...
    |    
    +---1:30(htb) prio 0 rate 1Kbit ceil 6Mbit burst 15Kb cburst 1599b 
                  Send 100 pkts ...
                  Rate 10mbit ...

The problem that this is huge now but looks better visually, I am
thinking also about to possibiliy to show only some part of tree by specified parent id ...

But how much classes can be used usually for traffic control per device ?

Regards,
Vadim Kochan